#!/bin/bash

MYTMPDIR=$(mktemp -d)
trap 'rm -rf "$MYTMPDIR"' EXIT INT TERM HUP

# temporary files
TMPDIMACS=`mktemp -p $MYTMPDIR`


echo "checking complete"

for ITER in {1..1000}
do

./generateComplete.sh 45 0.2 1236789$ITER > $TMPDIMACS

CNFRES=`java -jar /home/joh/Downloads/CNFChecker/dist/CNFChecker.jar < $TMPDIMACS`

if [[ "$CNFRES" != "valid" ]]; then
echo "error: CNF problem with 1236789"$ITER
fi

NUMBEROFMODS=`clasp 0 $TMPDIMACS | grep "c Models" | awk '{print $4}'`

NUMBEROFEXTS=`cat $TMPDIMACS | grep -o "c arg([0-9]*).\|c att([0-9]*,[0-9]*)."  | awk '{print $2}' | clingo - 0 comp.dl 2> /dev/null | grep "Models" | awk '{print $3}'`


echo "checking 123456789"$ITER". Results: "$NUMBEROFMODS" models and "$NUMBEROFEXTS" extensions"
if [[ "$NUMBEROFEXTS" != "$NUMBEROFMODS" ]]; then
echo "error: mismatch in 1236789"$ITER
fi

done

echo "checking stable"

for ITER in {1..1000}
do

./generateStable.sh 45 0.2 1236789$ITER > $TMPDIMACS

CNFRES=`java -jar /home/joh/Downloads/CNFChecker/dist/CNFChecker.jar < $TMPDIMACS`

if [[ "$CNFRES" != "valid" ]]; then
echo "error: CNF problem with 1236789"$ITER
fi

NUMBEROFMODS=`clasp 0 $TMPDIMACS | grep "c Models" | awk '{print $4}'`

NUMBEROFEXTS=`cat $TMPDIMACS | grep -o "c arg([0-9]*).\|c att([0-9]*,[0-9]*)."  | awk '{print $2}' | clingo - 0 stable.dl 2> /dev/null | grep "Models" | awk '{print $3}'`


echo "checking 123456789"$ITER". Results: "$NUMBEROFMODS" models and "$NUMBEROFEXTS" extensions"
if [[ "$NUMBEROFEXTS" != "$NUMBEROFMODS" ]]; then
echo "error: mismatch in 1236789"$ITER
fi

done